"""This module is used on every CLI operation"""
import os
import sys
import inspect
import imp
from symautomata.alphabet import createalphabet
sys.path.insert(1, imp.find_module('lightbulb')[1]+'/core/modules')
moduleNames = [name[:-3] for name in os.listdir(imp.find_module('lightbulb')[1]+'/core/modules')
               if name.endswith(".py")]

CORE = {}
CORE_META = {}
for moduleName in moduleNames:
    module = __import__(moduleName)
    classmembers = inspect.getmembers(module, inspect.isclass)
    CORE[classmembers[0][0]] = classmembers[0][1]
    CORE_META[classmembers[0][0]] = module.META

def options_as_dictionary(meta):
    """
    Transforms a list of tuples to a dictionary
    Args:
        meta (list): A list ot option tuples
    Retuns:
        dict: A dictionary of options key - values
    """
    module_config = {}
    for seltuple in meta:
        module_config.update({seltuple[0]: seltuple[1]})
    return  module_config

