import re
import urllib
import urllib2
from urllib2 import Request

class HTTPHandler:

    def __init__(self, url, request_type, param, block, bypass, proxy_scheme, proxy_host, proxy_port, proxy_username, proxy_password, user_agent, referer):
        self.url = url
        self.request_type = request_type
        self.param = param
        self.block = block
        self.bypass = bypass
        self.proxy_scheme = proxy_scheme
        self.proxy_host = proxy_host
        self.proxy_port = proxy_port
        self.proxy_username = proxy_username
        self.proxy_password = proxy_password
        self.user_agent = user_agent
        self.referer = referer



        if self.proxy_scheme is not None and self.proxy_host is not None and \
                        self.proxy_port is not None:
            credentials = ""
            if self.proxy_username is not None and self.proxy_password is not None:
                credentials = self.proxy_username + ":" + self.proxy_password + "@"
            proxyDict = {
                self.proxy_scheme: self.proxy_scheme + "://" + credentials +
                                                    self.proxy_host + ":" + self.proxy_port
            }

            proxy = urllib2.ProxyHandler(proxyDict)

            if credentials != '':
                auth = urllib2.HTTPBasicAuthHandler()
                opener = urllib2.build_opener(proxy, auth, urllib2.HTTPHandler)
            else:
                opener = urllib2.build_opener(proxy)
            urllib2.install_opener(opener)



    def do_query(self, string):
        """
        Perform a query
        Args:
           query (str): The SQL query
        Returns:
            bool: A success or failure response
        """

        concat_param = None

        if self.request_type == 'GET':
            concat_param = "?" + self.param + '=' + urllib.quote_plus(string)
        data = None

        if self.request_type == 'POST':
            data = self.param + '=' + urllib.quote_plus(string)
        #print self.url+"?" + self.param + '=' + string
        req = Request(
            self.url + concat_param,
            data=data,
            headers={
                'User-Agent': self.user_agent,
                'Referer': self.referer,
                "Accept": "text/html"})
        html = ''

        try:

            httpget = urllib2.urlopen(req)
            html = httpget.read()

        except urllib2.HTTPError as error:

            if error.code == 403:
                if self.block == None:
                    html = self.bypass
                elif self.bypass == None:
                    html = self.block
                else:
                    html = self.block + self.bypass
            else:
                print 'Can not connect. We failed with error code - %s.' % error.code
                exit()

        if self.block is not None and self.block != "":
            pattern = r'' + re.escape(self.block)
            hits = re.findall(pattern, html)
            if len(hits) > 0:
                #print 'True'
                return True
            else:
                #print 'False'
                return False

        if self.bypass is not None and self.bypass != "":
            pattern = r'' + re.escape(self.bypass)
            hits = re.findall(pattern, html)
            if len(hits) > 0:
                return False
            else:
                return True

        print 'Please give either a BLOCK or a BYPASS pattern'
        exit(1)