from lightbulb.core.base import CORE, options_as_dictionary, createalphabet
import imp
try:
    imp.find_module('MySQLdb')
    from lightbulb.core.utils.sql_handler import SQLHandler

    META = {
            'author': 'George Argyros, Ioannis Stais',
            'description': 'Learns a MySQL parser using a file containing regular expressions or grammar as input',
            'type':'GOFA',
            'options': [
                ('FILE', None, True, 'File containting regular expressions/grammar'),
                ('FILE_TYPE', "FLEX", True, 'File type (e.g FLEX, GRAMMAR, FST)'),
                ('HOST', "127.0.0.1", True, 'The target host'),
                ('PORT', "3306", True, 'The target port'),
                ('USERNAME', None, True, 'The required username'),
                ('PASSWORD', None, True, 'The required password'),
                ('DATABASE', None, True, 'The MySQL database'),
                ('PREFIX_QUERY', 'SELECT id FROM a WHERE a = **;', True, 'The sql query to be concatenated'),
                ('PRELOAD', True, True, 'Preload the input filter'),
                ('ALPHABET', None, False, 'File containing the alphabet'),
                ('SAVE', None, False, 'File to save learned filter if no bypass is found'),
            ],
            'comments': ['Sample comment 1', 'Sample comment 2']
        }

    class Module(CORE['GOFA']):


        def __init__(self, configuration):

            super(Module, self).__init__(createalphabet(configuration['ALPHABET']),  configuration['FILE'], configuration['FILE_TYPE'], configuration['PRELOAD'], configuration['SAVE'])

            self.sqlserver = SQLHandler(configuration['HOST'], int(configuration['PORT']), configuration['USERNAME'],
                                        configuration['PASSWORD'], configuration['DATABASE'], configuration['PREFIX_QUERY'], False)



        def _query(self, string):
            """
            Performs a membership query in the SQL database
            Args:
                string: The string to be tested
            Returns:
                bool: A boolean value indicating that the target parser accepts or rejects the input
            """
            return self.sqlserver.do_query(string)


except ImportError:
    pass